-- SPDX-FileCopyrightText: 2022 CERN (home.cern)
--
-- SPDX-License-Identifier: CERN-OHL-W-2.0+

-- Do not edit.  Generated by cheby 1.6.dev0 using these options:
--  -i slave_map.cheby --gen-hdl slave_map.vhd
-- Generated on Wed Dec 06 14:11:43 2023 by tgingold


library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wishbone_pkg.all;

entity vme2_map is
  port (
    rst_n_i              : in    std_logic;
    clk_i                : in    std_logic;
    wb_i                 : in    t_wishbone_slave_in;
    wb_o                 : out   t_wishbone_slave_out;

    -- The first register (with some fields)
    regA_o               : out   std_logic_vector(31 downto 0);

    -- SRAM bus mem32
    mem32_addr_o         : out   std_logic_vector(11 downto 2);
    mem32_data_i         : in    std_logic_vector(31 downto 0);
    mem32_data_o         : out   std_logic_vector(31 downto 0);
    mem32_wr_o           : out   std_logic
  );
end vme2_map;

architecture syn of vme2_map is
  signal adr_int                        : std_logic_vector(12 downto 2);
  signal rd_req_int                     : std_logic;
  signal wr_req_int                     : std_logic;
  signal rd_ack_int                     : std_logic;
  signal wr_ack_int                     : std_logic;
  signal wb_en                          : std_logic;
  signal ack_int                        : std_logic;
  signal wb_rip                         : std_logic;
  signal wb_wip                         : std_logic;
  signal regA_reg                       : std_logic_vector(31 downto 0);
  signal regA_wreq                      : std_logic;
  signal regA_wack                      : std_logic;
  signal mem32_rack                     : std_logic;
  signal mem32_re                       : std_logic;
  signal rd_ack_d0                      : std_logic;
  signal rd_dat_d0                      : std_logic_vector(31 downto 0);
  signal wr_req_d0                      : std_logic;
  signal wr_adr_d0                      : std_logic_vector(12 downto 2);
  signal wr_dat_d0                      : std_logic_vector(31 downto 0);
  signal mem32_wp                       : std_logic;
  signal mem32_we                       : std_logic;
begin

  -- WB decode signals
  adr_int <= wb_i.adr(12 downto 2);
  wb_en <= wb_i.cyc and wb_i.stb;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_rip <= '0';
      else
        wb_rip <= (wb_rip or (wb_en and not wb_i.we)) and not rd_ack_int;
      end if;
    end if;
  end process;
  rd_req_int <= (wb_en and not wb_i.we) and not wb_rip;

  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        wb_wip <= '0';
      else
        wb_wip <= (wb_wip or (wb_en and wb_i.we)) and not wr_ack_int;
      end if;
    end if;
  end process;
  wr_req_int <= (wb_en and wb_i.we) and not wb_wip;

  ack_int <= rd_ack_int or wr_ack_int;
  wb_o.ack <= ack_int;
  wb_o.stall <= not ack_int and wb_en;
  wb_o.rty <= '0';
  wb_o.err <= '0';

  -- pipelining for wr-in+rd-out
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        rd_ack_int <= '0';
        wb_o.dat <= "00000000000000000000000000000000";
        wr_req_d0 <= '0';
        wr_adr_d0 <= "00000000000";
        wr_dat_d0 <= "00000000000000000000000000000000";
      else
        rd_ack_int <= rd_ack_d0;
        wb_o.dat <= rd_dat_d0;
        wr_req_d0 <= wr_req_int;
        wr_adr_d0 <= adr_int;
        wr_dat_d0 <= wb_i.dat;
      end if;
    end if;
  end process;

  -- Register const_0

  -- Register const_1

  -- Register regA
  regA_o <= regA_reg;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        regA_reg <= "00000000000000000000000000000000";
        regA_wack <= '0';
      else
        if regA_wreq = '1' then
          regA_reg <= wr_dat_d0;
        end if;
        regA_wack <= regA_wreq;
      end if;
    end if;
  end process;

  -- Interface mem32
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        mem32_rack <= '0';
      else
        mem32_rack <= mem32_re and not mem32_rack;
      end if;
    end if;
  end process;
  mem32_data_o <= wr_dat_d0;
  process (clk_i) begin
    if rising_edge(clk_i) then
      if rst_n_i = '0' then
        mem32_wp <= '0';
      else
        mem32_wp <= (wr_req_d0 or mem32_wp) and rd_req_int;
      end if;
    end if;
  end process;
  mem32_we <= (wr_req_d0 or mem32_wp) and not rd_req_int;
  process (adr_int, wr_adr_d0, mem32_re) begin
    if mem32_re = '1' then
      mem32_addr_o <= adr_int(11 downto 2);
    else
      mem32_addr_o <= wr_adr_d0(11 downto 2);
    end if;
  end process;

  -- Process for write requests.
  process (wr_adr_d0, wr_req_d0, regA_wack, mem32_we) begin
    regA_wreq <= '0';
    mem32_wr_o <= '0';
    case wr_adr_d0(12 downto 12) is
    when "0" =>
      case wr_adr_d0(11 downto 2) is
      when "0000000000" =>
        -- Reg const_0
        wr_ack_int <= wr_req_d0;
      when "0000000001" =>
        -- Reg const_1
        wr_ack_int <= wr_req_d0;
      when "0000000010" =>
        -- Reg regA
        regA_wreq <= wr_req_d0;
        wr_ack_int <= regA_wack;
      when others =>
        wr_ack_int <= wr_req_d0;
      end case;
    when "1" =>
      -- Submap mem32
      mem32_wr_o <= mem32_we;
      wr_ack_int <= mem32_we;
    when others =>
      wr_ack_int <= wr_req_d0;
    end case;
  end process;

  -- Process for read requests.
  process (adr_int, rd_req_int, regA_reg, mem32_data_i, mem32_rack) begin
    -- By default ack read requests
    rd_dat_d0 <= (others => 'X');
    mem32_re <= '0';
    case adr_int(12 downto 12) is
    when "0" =>
      case adr_int(11 downto 2) is
      when "0000000000" =>
        -- Reg const_0
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0 <= "00010010001101000101011001111000";
      when "0000000001" =>
        -- Reg const_1
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0 <= "10011010101111001101111011110000";
      when "0000000010" =>
        -- Reg regA
        rd_ack_d0 <= rd_req_int;
        rd_dat_d0 <= regA_reg;
      when others =>
        rd_ack_d0 <= rd_req_int;
      end case;
    when "1" =>
      -- Submap mem32
      rd_dat_d0 <= mem32_data_i;
      rd_ack_d0 <= mem32_rack;
      mem32_re <= rd_req_int;
    when others =>
      rd_ack_d0 <= rd_req_int;
    end case;
  end process;
end syn;
